diff -cr sendmail-8.9.0/src/makesendmail sendmail-8.9.1/src/makesendmail
*** sendmail-8.9.0/src/makesendmail	Tue May 19 16:33:54 1998
--- sendmail-8.9.1/src/makesendmail	Wed Jun 24 21:10:11 1998
***************
*** 10,16 ****
  # the sendmail distribution.
  #
  #
! #       @(#)Build	8.88 (Berkeley) 5/19/98
  #
  
  #
--- 10,16 ----
  # the sendmail distribution.
  #
  #
! #       @(#)Build	8.93 (Berkeley) 6/24/98
  #
  
  #
***************
*** 155,160 ****
--- 155,166 ----
  		rel=Mach
  		arch=luna88k
  	fi
+ elif [ -d /usr/apollo -a -d \`node_data ]
+ then
+ 	# probably a Apollo/DOMAIN
+ 	os=DomainOS
+ 	arch=$ISP
+ 	rel=`/usr/apollo/bin/bldt | grep Domain | awk '{ print $4 }' | sed -e 's/,//g'`
  fi
  
  if [ ! "$arch" -a ! "$os" -a ! "$rel" ]
***************
*** 234,239 ****
--- 240,249 ----
  			rel=`uname -v | sed -e 's/\(V.*\)L.*/\1/'`
  		fi;;
    SINIX-?)	os=SINIX;;
+   DomainOS)	case $rel in
+ 		  10.4*)	rel=10.4;;
+ 		esac
+ 		;;
  esac
  
  # get "base part" of operating system release
***************
*** 296,301 ****
--- 306,317 ----
  BUILDTOOLS=${BUILDTOOLS-$SMROOT/BuildTools}
  export SMROOT BUILDTOOLS
  
+ # see if we are in a Build-able directory
+ if [ ! -f Makefile.m4 ]; then
+ 	echo "Makefile.m4 not found.  Build can only be run from a source directory."
+ 	exit $EX_UNAVAILABLE
+ fi
+ 
  # now try to find a reasonable object directory
  if [ -r obj.$os.$rel.$arch$sfx ]; then
  	obj=obj.$os.$rel.$arch$sfx
***************
*** 436,442 ****
  		fi
  		if [ -f $BUILDTOOLS/Site/site.config.m4 ]
  		then
! 			siteconfig=$BUILDTOOLS/Site/site.config.m4
  		fi
  	fi
  	if [ ! -z "$siteconfig" ]
--- 452,458 ----
  		fi
  		if [ -f $BUILDTOOLS/Site/site.config.m4 ]
  		then
! 			siteconfig="$BUILDTOOLS/Site/site.config.m4 $siteconfig"
  		fi
  	fi
  	if [ ! -z "$siteconfig" ]
***************
*** 454,474 ****
  	fi
  	echo 'divert(0)dnl' >> $obj/.settings$$
  	libdirs=`(cat $obj/.settings$$; echo "_SRIDBIL_= confLIBDIRS" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_SRIDBIL_=" | \
! 		sed -e 's/_include_/include/g' -e "s/^_SRIDBIL_=//"`
  	libsrch=`(cat $obj/.settings$$; echo "_HCRSBIL_= confLIBSEARCH" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_HCRSBIL_=" | \
! 		sed -e 's/_include_/include/g' -e "s/^_HCRSBIL_=//"`
  	echo 'divert(-1)' >> $obj/.settings$$
  	LIBDIRS="$libdirs" LIBSRCH="$libsrch" SITECONFIG="$siteconfig" sh $BUILDTOOLS/bin/configure.sh $sflag $oscf >> $obj/.settings$$
  	echo 'divert(0)dnl' >> $obj/.settings$$
! 	sed -e 's/\(.\)include/\1_include_/g' $obj/.settings$$ | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - Makefile.m4 | \
! 		sed 's/_include_/include/g' > $obj/Makefile
  	if [ $? -ne 0 -o ! -s $obj/Makefile ]
  	then
  		echo "ERROR: ${M4} failed; You may need a newer version of M4, at least as new as System V or GNU" 1>&2
--- 470,490 ----
  	fi
  	echo 'divert(0)dnl' >> $obj/.settings$$
  	libdirs=`(cat $obj/.settings$$; echo "_SRIDBIL_= confLIBDIRS" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_SRIDBIL_=" | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' -e "s/^_SRIDBIL_=//"`
  	libsrch=`(cat $obj/.settings$$; echo "_HCRSBIL_= confLIBSEARCH" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_HCRSBIL_=" | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' -e "s/^_HCRSBIL_=//"`
  	echo 'divert(-1)' >> $obj/.settings$$
  	LIBDIRS="$libdirs" LIBSRCH="$libsrch" SITECONFIG="$siteconfig" sh $BUILDTOOLS/bin/configure.sh $sflag $oscf >> $obj/.settings$$
  	echo 'divert(0)dnl' >> $obj/.settings$$
! 	sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' $obj/.settings$$ | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - Makefile.m4 | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' > $obj/Makefile
  	if [ $? -ne 0 -o ! -s $obj/Makefile ]
  	then
  		echo "ERROR: ${M4} failed; You may need a newer version of M4, at least as new as System V or GNU" 1>&2
***************
*** 488,504 ****
  		echo "ERROR: $obj exists but has no Makefile" >&2
  		exit $EX_NOINPUT
  	fi
! 	case $makefile
! 	in
! 	  ../Makefiles/*)
! 		makefile=`echo $makefile | sed 's/...Makefiles.//'`
! 		echo "Will run in existing $obj using $makefile"
! 		;;
! 
! 	  *)
! 		echo "Will run in existing $obj using custom $makefile"
! 		;;
! 	esac
  	exit 0
  fi
  
--- 504,510 ----
  		echo "ERROR: $obj exists but has no Makefile" >&2
  		exit $EX_NOINPUT
  	fi
! 	echo "Will run in existing $obj using $makefile"
  	exit 0
  fi
  
diff -cr sendmail-8.9.0/src/map.c sendmail-8.9.1/src/map.c
*** sendmail-8.9.0/src/map.c	Tue May 19 16:36:10 1998
--- sendmail-8.9.1/src/map.c	Fri Jun  5 14:51:02 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)map.c	8.236 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  #include "sendmail.h"
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)map.c	8.239 (Berkeley) 6/5/98";
  #endif /* not lint */
  
  #include "sendmail.h"
***************
*** 921,928 ****
  		return FALSE;
  	}
  
! 	if (filechanged(dirfile, dfd, &std, sff) ||
! 	    filechanged(pagfile, pfd, &stp, sff))
  	{
  		int save_errno = errno;
  
--- 921,928 ----
  		return FALSE;
  	}
  
! 	if (filechanged(dirfile, dfd, &std) ||
! 	    filechanged(pagfile, pfd, &stp))
  	{
  		int save_errno = errno;
  
***************
*** 953,958 ****
--- 953,972 ----
  	else
  	{
  		map->map_mflags |= MF_LOCKED;
+ 		if (geteuid() == 0 && TrustedFileUid != 0)
+ 		{
+ 			if (fchown(dfd, TrustedFileUid, -1) < 0 ||
+ 			    fchown(pfd, TrustedFileUid, -1) < 0)
+ 			{
+ 				int err = errno;
+ 
+ 				sm_syslog(LOG_ALERT, NOQID,
+ 					  "ownership change on %s failed: %s",
+ 					  map->map_file, errstring(err));
+ 				message("050 ownership change on %s failed: %s",
+ 					map->map_file, errstring(err));
+ 			}
+ 		}
  	}
  	if (fstat(dfd, &st) >= 0)
  		map->map_mtime = st.st_mtime;
***************
*** 1102,1108 ****
  			auto int xstat;
  			datum old;
  
! 			old.dptr = ndbm_map_lookup(map, key.dptr, NULL, &xstat);
  			if (old.dptr != NULL && *(char *) old.dptr != '\0')
  			{
  				old.dsize = strlen(old.dptr);
--- 1116,1123 ----
  			auto int xstat;
  			datum old;
  
! 			old.dptr = ndbm_map_lookup(map, key.dptr,
! 						   (char **)NULL, &xstat);
  			if (old.dptr != NULL && *(char *) old.dptr != '\0')
  			{
  				old.dsize = strlen(old.dptr);
***************
*** 1374,1380 ****
  	}
  
  	/* make sure no baddies slipped in just before the open... */
! 	if (filechanged(buf, fd, &st, sff))
  	{
  		int save_errno = errno;
  
--- 1389,1395 ----
  	}
  
  	/* make sure no baddies slipped in just before the open... */
! 	if (filechanged(buf, fd, &st))
  	{
  		int save_errno = errno;
  
***************
*** 1454,1460 ****
  	fd = -1;
  	errno = db->fd(db, &fd);
  #endif
! 	if (filechanged(buf, fd, &st, sff))
  	{
  		int save_errno = errno;
  
--- 1469,1475 ----
  	fd = -1;
  	errno = db->fd(db, &fd);
  #endif
! 	if (filechanged(buf, fd, &st))
  	{
  		int save_errno = errno;
  
***************
*** 1483,1489 ****
--- 1498,1519 ----
  
  	/* try to make sure that at least the database header is on disk */
  	if (mode == O_RDWR)
+ 	{
  		(void) db->sync(db, 0);
+ 		if (geteuid() == 0 && TrustedFileUid != 0)
+ 		{
+ 			if (fchown(fd, TrustedFileUid, -1) < 0)
+ 			{
+ 				int err = errno;
+ 
+ 				sm_syslog(LOG_ALERT, NOQID,
+ 					  "ownership change on %s failed: %s",
+ 					  buf, errstring(err));
+ 				message("050 ownership change on %s failed: %s",
+ 					buf, errstring(err));
+ 			}
+ 		}
+ 	}
  
  	if (fd >= 0 && fstat(fd, &st) >= 0)
  		map->map_mtime = st.st_mtime;
***************
*** 1725,1731 ****
  
  			bzero(&old, sizeof old);
  
! 			old.data = db_map_lookup(map, key.data, NULL, &stat);
  			if (old.data != NULL)
  			{
  				old.size = strlen(old.data);
--- 1755,1762 ----
  
  			bzero(&old, sizeof old);
  
! 			old.data = db_map_lookup(map, key.data, 
! 						 (char **)NULL, &stat);
  			if (old.data != NULL)
  			{
  				old.size = strlen(old.data);
***************
*** 1895,1900 ****
--- 1926,1932 ----
  **  NIS_MAP_LOOKUP -- look up a datum in a NIS map
  */
  
+ /* ARGSUSED3 */
  char *
  nis_map_lookup(map, name, av, statp)
  	MAP *map;
***************
*** 3887,3892 ****
--- 3919,3925 ----
  **  STAB_MAP_LOOKUP -- look up alias in symbol table
  */
  
+ /* ARGSUSED2 */
  char *
  stab_map_lookup(map, name, av, pstat)
  	register MAP *map;
***************
*** 4172,4177 ****
--- 4205,4211 ----
  **  USER_MAP_LOOKUP -- look up a user in the passwd file.
  */
  
+ /* ARGSUSED3 */
  char *
  user_map_lookup(map, key, av, statp)
  	MAP *map;
***************
*** 4601,4606 ****
--- 4635,4641 ----
  **  NULL stubs
  */
  
+ /* ARGSUSED */
  bool
  null_map_open(map, mode)
  	MAP *map;
***************
*** 4609,4614 ****
--- 4644,4650 ----
  	return TRUE;
  }
  
+ /* ARGSUSED */
  void
  null_map_close(map)
  	MAP *map;
***************
*** 4627,4632 ****
--- 4663,4669 ----
  	return NULL;
  }
  
+ /* ARGSUSED */
  void
  null_map_store(map, key, val)
  	MAP *map;
diff -cr sendmail-8.9.0/src/mci.c sendmail-8.9.1/src/mci.c
*** sendmail-8.9.0/src/mci.c	Tue May 19 16:36:10 1998
--- sendmail-8.9.1/src/mci.c	Mon Jun 15 11:03:17 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)mci.c	8.81 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  #include "sendmail.h"
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)mci.c	8.82 (Berkeley) 6/15/98";
  #endif /* not lint */
  
  #include "sendmail.h"
***************
*** 805,811 ****
  			return 0;
  
  		  default:
! 			syserr("Unknown host status line \"%s\"", buf);
  			LineNumber = saveLineNumber;
  			return -1;
  		}
--- 805,814 ----
  			return 0;
  
  		  default:
! 			sm_syslog(LOG_CRIT, NOQID,
! 				  "%s: line %d: Unknown host status line \"%s\"",
! 				  FileName == NULL ? mci->mci_host : FileName,
! 				  LineNumber, buf);
  			LineNumber = saveLineNumber;
  			return -1;
  		}
diff -cr sendmail-8.9.0/src/parseaddr.c sendmail-8.9.1/src/parseaddr.c
*** sendmail-8.9.0/src/parseaddr.c	Tue May 19 16:36:04 1998
--- sendmail-8.9.1/src/parseaddr.c	Wed Jun 24 15:07:53 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)parseaddr.c	8.150 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  # include "sendmail.h"
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)parseaddr.c	8.153 (Berkeley) 6/24/98";
  #endif /* not lint */
  
  # include "sendmail.h"
***************
*** 1066,1072 ****
  					char *mval = macvalue(rp[1], e);
  					char **xpvp;
  					int trsize = 0;
! 					char pvpb1[MAXATOM + 1];
  					char pvpbuf[PSBUFSIZE];
  
  					if (tTd(21, 2))
--- 1066,1073 ----
  					char *mval = macvalue(rp[1], e);
  					char **xpvp;
  					int trsize = 0;
! 					static size_t pvpb1_size = 0;
! 					static char **pvpb1 = NULL;
  					char pvpbuf[PSBUFSIZE];
  
  					if (tTd(21, 2))
***************
*** 1079,1084 ****
--- 1080,1093 ----
  					/* save the remainder of the input */
  					for (xpvp = pvp; *xpvp != NULL; xpvp++)
  						trsize += sizeof *xpvp;
+ 					if (trsize > pvpb1_size)
+ 					{
+ 						if (pvpb1 != NULL)
+ 							free(pvpb1);
+ 						pvpb1 = (char **)xalloc(trsize);
+ 						pvpb1_size = trsize;
+ 					}
+ 
  					bcopy((char *) pvp, (char *) pvpb1, trsize);
  
  					/* scan the new replacement */
***************
*** 1464,1470 ****
  			snprintf(mbuf, sizeof mbuf,
  				"%.80s map: lookup (%s): deferred",
  				map->s_name,
! 				shortenstring(key, 203));
  			e->e_message = newstr(mbuf);
  		}
  	}
--- 1473,1479 ----
  			snprintf(mbuf, sizeof mbuf,
  				"%.80s map: lookup (%s): deferred",
  				map->s_name,
! 				shortenstring(key, MAXSHORTSTR));
  			e->e_message = newstr(mbuf);
  		}
  	}
***************
*** 2296,2301 ****
--- 2305,2311 ----
  **		else -- The dequoted buffer.
  */
  
+ /* ARGSUSED2 */
  char *
  dequote_map(map, name, av, statp)
  	MAP *map;
***************
*** 2454,2460 ****
  			printf("rscheck: cannot prescan input\n");
  /*
  		syserr("rscheck: cannot prescan input: \"%s\"",
! 			shortenstring(buf, 203));
  		rstat = EX_DATAERR;
  */
  		goto finis;
--- 2464,2470 ----
  			printf("rscheck: cannot prescan input\n");
  /*
  		syserr("rscheck: cannot prescan input: \"%s\"",
! 			shortenstring(buf, MAXSHORTSTR));
  		rstat = EX_DATAERR;
  */
  		goto finis;
diff -cr sendmail-8.9.0/src/queue.c sendmail-8.9.1/src/queue.c
*** sendmail-8.9.0/src/queue.c	Tue May 19 16:36:08 1998
--- sendmail-8.9.1/src/queue.c	Mon Jun 15 10:32:26 1998
***************
*** 14,22 ****
  
  #ifndef lint
  #if QUEUE
! static char sccsid[] = "@(#)queue.c	8.200 (Berkeley) 5/19/98 (with queueing)";
  #else
! static char sccsid[] = "@(#)queue.c	8.200 (Berkeley) 5/19/98 (without queueing)";
  #endif
  #endif /* not lint */
  
--- 14,22 ----
  
  #ifndef lint
  #if QUEUE
! static char sccsid[] = "@(#)queue.c	8.202 (Berkeley) 6/15/98 (with queueing)";
  #else
! static char sccsid[] = "@(#)queue.c	8.202 (Berkeley) 6/15/98 (without queueing)";
  #endif
  #endif /* not lint */
  
***************
*** 987,992 ****
--- 987,993 ----
  		while (i != 0 && fgets(lbuf, sizeof lbuf, cf) != NULL)
  		{
  			int c;
+ 			time_t age;
  			extern bool strcontainedin __P((char *, char *));
  
  			p = strchr(lbuf, '\n');
***************
*** 1060,1066 ****
  				break;
  
  			  case 'K':
! 				if ((curtime() - (time_t) atol(&lbuf[1])) < MinQueueAge)
  					w->w_tooyoung = TRUE;
  				break;
  
--- 1061,1069 ----
  				break;
  
  			  case 'K':
! 				age = curtime() - (time_t) atol(&lbuf[1]);
! 				if (age >= 0 && MinQueueAge > 0 &&
! 				    age < MinQueueAge)
  					w->w_tooyoung = TRUE;
  				break;
  
***************
*** 1770,1775 ****
--- 1773,1779 ----
  
  			/* if this has been tried recently, let it be */
  			if (e->e_ntries > 0 &&
+ 			    MinQueueAge > 0 && e->e_dtime <= curtime() &&
  			    curtime() < e->e_dtime + MinQueueAge)
  			{
  				char *howlong = pintvl(curtime() - e->e_dtime, TRUE);
***************
*** 1847,1853 ****
  
  		  default:
  			syserr("readqf: %s: line %d: bad line \"%s\"",
! 				qf, LineNumber, shortenstring(bp, 203));
  			fclose(qfp);
  			loseqfile(e, "unrecognized line");
  			return FALSE;
--- 1851,1857 ----
  
  		  default:
  			syserr("readqf: %s: line %d: bad line \"%s\"",
! 				qf, LineNumber, shortenstring(bp, MAXSHORTSTR));
  			fclose(qfp);
  			loseqfile(e, "unrecognized line");
  			return FALSE;
diff -cr sendmail-8.9.0/src/readcf.c sendmail-8.9.1/src/readcf.c
*** sendmail-8.9.0/src/readcf.c	Tue May 19 16:36:08 1998
--- sendmail-8.9.1/src/readcf.c	Mon Jun  8 14:57:05 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)readcf.c	8.229 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  # include "sendmail.h"
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)readcf.c	8.230 (Berkeley) 6/5/98";
  #endif /* not lint */
  
  # include "sendmail.h"
***************
*** 1515,1520 ****
--- 1515,1524 ----
  #define O_CNCTONLYTO	0xa6
  	{ "ConnectOnlyTo",		O_CNCTONLYTO,	FALSE	},
  #endif
+ #if _FFR_TRUSTED_FILE_OWNER
+ #define O_TRUSTFILEOWN	0xa7
+ 	{ "TrustedFileOwner",		O_TRUSTFILEOWN,	FALSE	},
+ #endif
  
  	{ NULL,				'\0',		FALSE	}
  };
***************
*** 2394,2399 ****
--- 2398,2430 ----
  	  case O_CNCTONLYTO:
  		/* XXX should probably use gethostbyname */
  		ConnectOnlyTo = inet_addr(val);
+ 		break;
+ #endif
+ 
+ #if _FFR_TRUSTED_FILE_OWNER
+ 	  case O_TRUSTFILEOWN:
+ 		if (isascii(*val) && isdigit(*val))
+ 			TrustedFileUid = atoi(val);
+ 		else
+ 		{
+ 			register struct passwd *pw;
+ 
+ 			TrustedFileUid = 0;
+ 			pw = sm_getpwnam(val);
+ 			if (pw == NULL)
+ 				syserr("readcf: option TrustedFileOwner: unknown user %s", val);
+ 			else
+ 				TrustedFileUid = pw->pw_uid;
+ 		}
+ 
+ #ifdef UID_MAX
+ 		if (TrustedFileUid > UID_MAX)
+ 		{
+ 			syserr("readcf: option TrustedFileOwner: uid value (%ld) > UID_MAX (%ld)",
+ 				TrustedFileUid, UID_MAX);
+ 			TrustedFileUid = 0;
+ 		}
+ #endif
  		break;
  #endif
  
diff -cr sendmail-8.9.0/src/recipient.c sendmail-8.9.1/src/recipient.c
*** sendmail-8.9.0/src/recipient.c	Tue May 19 16:36:03 1998
--- sendmail-8.9.1/src/recipient.c	Wed Jun 24 14:32:29 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)recipient.c	8.151 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  # include "sendmail.h"
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)recipient.c	8.154 (Berkeley) 6/24/98";
  #endif /* not lint */
  
  # include "sendmail.h"
***************
*** 365,376 ****
  				if (LogLevel > 2)
  					sm_syslog(LOG_ERR, e->e_id,
  						"include %s: transient error: %s",
! 						shortenstring(a->q_user, 203),
  						errstring(ret));
  				a->q_flags |= QQUEUEUP;
  				a->q_flags &= ~QDONTSEND;
  				usrerr("451 Cannot open %s: %s",
! 					shortenstring(a->q_user, 203),
  					errstring(ret));
  			}
  			else if (ret != 0)
--- 365,376 ----
  				if (LogLevel > 2)
  					sm_syslog(LOG_ERR, e->e_id,
  						"include %s: transient error: %s",
! 						shortenstring(a->q_user, MAXSHORTSTR),
  						errstring(ret));
  				a->q_flags |= QQUEUEUP;
  				a->q_flags &= ~QDONTSEND;
  				usrerr("451 Cannot open %s: %s",
! 					shortenstring(a->q_user, MAXSHORTSTR),
  					errstring(ret));
  			}
  			else if (ret != 0)
***************
*** 378,384 ****
  				a->q_flags |= QBADADDR;
  				a->q_status = "5.2.4";
  				usrerr("550 Cannot open %s: %s",
! 					shortenstring(a->q_user, 203),
  					errstring(ret));
  			}
  		}
--- 378,384 ----
  				a->q_flags |= QBADADDR;
  				a->q_status = "5.2.4";
  				usrerr("550 Cannot open %s: %s",
! 					shortenstring(a->q_user, MAXSHORTSTR),
  					errstring(ret));
  			}
  		}
***************
*** 1045,1051 ****
  			}
  			else
  				sfflags |= SFF_SAFEDIRPATH;
! 			if (!bitset((forwarding ?
  				     DBS_FORWARDFILEINUNSAFEDIRPATHSAFE :
  				     DBS_INCLUDEFILEINUNSAFEDIRPATHSAFE),
  				    DontBlameSendmail))
--- 1045,1052 ----
  			}
  			else
  				sfflags |= SFF_SAFEDIRPATH;
! 			if (ret > E_PSEUDOBASE &&
! 			    !bitset((forwarding ?
  				     DBS_FORWARDFILEINUNSAFEDIRPATHSAFE :
  				     DBS_INCLUDEFILEINUNSAFEDIRPATHSAFE),
  				    DontBlameSendmail))
***************
*** 1053,1059 ****
  				if (LogLevel >= 12)
  					sm_syslog(LOG_INFO, e->e_id,
  						  "%s: unsafe directory path, marked unsafe",
! 						  shortenstring(fname, 203));
  				ctladdr->q_flags |= QUNSAFEADDR;
  			}
  		}
--- 1054,1060 ----
  				if (LogLevel >= 12)
  					sm_syslog(LOG_INFO, e->e_id,
  						  "%s: unsafe directory path, marked unsafe",
! 						  shortenstring(fname, MAXSHORTSTR));
  				ctladdr->q_flags |= QUNSAFEADDR;
  			}
  		}
***************
*** 1082,1088 ****
  		if (tTd(27, 4))
  			printf("include: open: %s\n", errstring(rval));
  	}
! 	else if (filechanged(fname, fileno(fp), &st, sfflags))
  	{
  		rval = E_SM_FILECHANGE;
  		if (tTd(27, 4))
--- 1083,1089 ----
  		if (tTd(27, 4))
  			printf("include: open: %s\n", errstring(rval));
  	}
! 	else if (filechanged(fname, fileno(fp), &st))
  	{
  		rval = E_SM_FILECHANGE;
  		if (tTd(27, 4))
***************
*** 1173,1179 ****
  				if (LogLevel >= 12)
  					sm_syslog(LOG_INFO, e->e_id,
  						"%s: user %s has bad shell %s, marked %s",
! 						shortenstring(fname, 203),
  						pw->pw_name, sh,
  						safechown ? "bogus" : "unsafe");
  				if (safechown)
--- 1174,1180 ----
  				if (LogLevel >= 12)
  					sm_syslog(LOG_INFO, e->e_id,
  						"%s: user %s has bad shell %s, marked %s",
! 						shortenstring(fname, MAXSHORTSTR),
  						pw->pw_name, sh,
  						safechown ? "bogus" : "unsafe");
  				if (safechown)
***************
*** 1212,1223 ****
  	{
  		if (tTd(27, 6))
  			printf("include: %s is %s writable, marked unsafe\n",
! 				shortenstring(fname, 203),
  				bitset(S_IWOTH, st.st_mode) ? "world" : "group");
  		if (LogLevel >= 12)
  			sm_syslog(LOG_INFO, e->e_id,
  				"%s: %s writable %s file, marked unsafe",
! 				shortenstring(fname, 203),
  				bitset(S_IWOTH, st.st_mode) ? "world" : "group",
  				forwarding ? "forward" : ":include:");
  		ctladdr->q_flags |= QUNSAFEADDR;
--- 1213,1224 ----
  	{
  		if (tTd(27, 6))
  			printf("include: %s is %s writable, marked unsafe\n",
! 				shortenstring(fname, MAXSHORTSTR),
  				bitset(S_IWOTH, st.st_mode) ? "world" : "group");
  		if (LogLevel >= 12)
  			sm_syslog(LOG_INFO, e->e_id,
  				"%s: %s writable %s file, marked unsafe",
! 				shortenstring(fname, MAXSHORTSTR),
  				bitset(S_IWOTH, st.st_mode) ? "world" : "group",
  				forwarding ? "forward" : ":include:");
  		ctladdr->q_flags |= QUNSAFEADDR;
***************
*** 1259,1265 ****
  		if (forwarding && LogLevel > 9)
  			sm_syslog(LOG_INFO, e->e_id,
  				"forward %.200s => %s",
! 				oldto, shortenstring(buf, 203));
  
  		nincludes += sendtolist(buf, ctladdr, sendq, aliaslevel + 1, e);
  	}
--- 1260,1266 ----
  		if (forwarding && LogLevel > 9)
  			sm_syslog(LOG_INFO, e->e_id,
  				"forward %.200s => %s",
! 				oldto, shortenstring(buf, MAXSHORTSTR));
  
  		nincludes += sendtolist(buf, ctladdr, sendq, aliaslevel + 1, e);
  	}
diff -cr sendmail-8.9.0/src/safefile.c sendmail-8.9.1/src/safefile.c
*** sendmail-8.9.0/src/safefile.c	Tue May 19 16:36:11 1998
--- sendmail-8.9.1/src/safefile.c	Fri Jun  5 14:51:02 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)safefile.c	8.38 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  # include "sendmail.h"
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)safefile.c	8.40 (Berkeley) 6/5/98";
  #endif /* not lint */
  
  # include "sendmail.h"
***************
*** 101,107 ****
  #ifdef SUID_ROOT_FILES_OK
  		if (bitset(S_ISUID, st->st_mode))
  #else
! 		if (bitset(S_ISUID, st->st_mode) && st->st_uid != 0)
  #endif
  		{
  			uid = st->st_uid;
--- 101,108 ----
  #ifdef SUID_ROOT_FILES_OK
  		if (bitset(S_ISUID, st->st_mode))
  #else
! 		if (bitset(S_ISUID, st->st_mode) && st->st_uid != 0 &&
! 		    st->st_uid != TrustedFileUid)
  #endif
  		{
  			uid = st->st_uid;
***************
*** 203,209 ****
  		{
  			int md = S_IWRITE|S_IEXEC;
  
! 			if (stbuf.st_uid != uid)
  			{
  				md >>= 3;
  				if (stbuf.st_gid == gid)
--- 204,214 ----
  		{
  			int md = S_IWRITE|S_IEXEC;
  
! 			if (stbuf.st_uid == uid)
! 				;
! 			else if (uid == 0 && TrustedFileUid != 0 && stbuf.st_uid == TrustedFileUid)
! 				;
! 			else
  			{
  				md >>= 3;
  				if (stbuf.st_gid == gid)
***************
*** 292,298 ****
  		;
  	else if (uid == 0 && !bitset(SFF_ROOTOK, flags))
  		mode >>= 6;
! 	else if (st->st_uid != uid)
  	{
  		mode >>= 3;
  		if (st->st_gid == gid)
--- 297,307 ----
  		;
  	else if (uid == 0 && !bitset(SFF_ROOTOK, flags))
  		mode >>= 6;
! 	else if (st->st_uid == uid)
! 		;
! 	else if (uid == 0 && TrustedFileUid != 0 && st->st_uid == TrustedFileUid)
! 		;
! 	else
  	{
  		mode >>= 3;
  		if (st->st_gid == gid)
***************
*** 319,324 ****
--- 328,334 ----
  			(int) st->st_uid, (int) st->st_nlink,
  			(u_long) st->st_mode, (u_long) mode);
  	if ((st->st_uid == uid || st->st_uid == 0 ||
+ 	     st->st_uid == TrustedFileUid ||
  	     !bitset(SFF_MUSTOWN, flags)) &&
  	    (st->st_mode & mode) == mode)
  	{
***************
*** 527,533 ****
  	fd = dfopen(fn, omode, cmode, sff);
  	if (fd < 0)
  		return fd;
! 	if (filechanged(fn, fd, &stb, sff))
  	{
  		syserr("554 cannot open: file %s changed after open", fn);
  		close(fd);
--- 537,543 ----
  	fd = dfopen(fn, omode, cmode, sff);
  	if (fd < 0)
  		return fd;
! 	if (filechanged(fn, fd, &stb))
  	{
  		syserr("554 cannot open: file %s changed after open", fn);
  		close(fd);
***************
*** 616,622 ****
  **		fn -- pathname of file to check.
  **		fd -- file descriptor to check.
  **		stb -- stat structure from before open.
- **		sff -- safe file flags.
  **
  **	Returns:
  **		TRUE -- if a problem was detected.
--- 626,631 ----
***************
*** 624,634 ****
  */
  
  bool
! filechanged(fn, fd, stb, sff)
  	char *fn;
  	int fd;
  	struct stat *stb;
- 	int sff;
  {
  	struct stat sta;
  
--- 633,642 ----
  */
  
  bool
! filechanged(fn, fd, stb)
  	char *fn;
  	int fd;
  	struct stat *stb;
  {
  	struct stat sta;
  
diff -cr sendmail-8.9.0/src/savemail.c sendmail-8.9.1/src/savemail.c
*** sendmail-8.9.0/src/savemail.c	Tue May 19 16:36:06 1998
--- sendmail-8.9.1/src/savemail.c	Wed Jun 17 10:20:00 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)savemail.c	8.136 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  # include "sendmail.h"
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)savemail.c	8.138 (Berkeley) 6/17/98";
  #endif /* not lint */
  
  # include "sendmail.h"
***************
*** 345,350 ****
--- 345,352 ----
  			define('z', p, e);
  			expand("\201z/dead.letter", buf, sizeof buf, e);
  			flags = SFF_CREAT|SFF_REGONLY|SFF_RUNASREALUID;
+ 			if (RealUid == 0)
+ 				flags |= SFF_ROOTOK;
  			e->e_to = buf;
  			if (mailfile(buf, FileMailer, NULL, flags, e) == EX_OK)
  			{
***************
*** 541,547 ****
  			p = "DSN";
  		sm_syslog(LOG_INFO, e->e_id,
  			"%s: %s: %s",
! 			ee->e_id, p, shortenstring(msg, 203));
  	}
  
  	if (SendMIMEErrors)
--- 543,549 ----
  			p = "DSN";
  		sm_syslog(LOG_INFO, e->e_id,
  			"%s: %s: %s",
! 			ee->e_id, p, shortenstring(msg, MAXSHORTSTR));
  	}
  
  	if (SendMIMEErrors)
***************
*** 786,797 ****
  			printheader = FALSE;
  		}
  
! 		snprintf(buf, sizeof buf, "%s", shortenstring(q->q_paddr, 203));
  		putline(buf, mci);
  		if (q->q_alias != NULL)
  		{
  			snprintf(buf, sizeof buf, "    (expanded from: %s)",
! 				shortenstring(q->q_alias->q_paddr, 203));
  			putline(buf, mci);
  		}
  	}
--- 788,800 ----
  			printheader = FALSE;
  		}
  
! 		snprintf(buf, sizeof buf, "%s",
! 			 shortenstring(q->q_paddr, MAXSHORTSTR));
  		putline(buf, mci);
  		if (q->q_alias != NULL)
  		{
  			snprintf(buf, sizeof buf, "    (expanded from: %s)",
! 				shortenstring(q->q_alias->q_paddr, MAXSHORTSTR));
  			putline(buf, mci);
  		}
  	}
***************
*** 813,824 ****
  			printheader = FALSE;
  		}
  
! 		snprintf(buf, sizeof buf, "%s", shortenstring(q->q_paddr, 203));
  		putline(buf, mci);
  		if (q->q_alias != NULL)
  		{
  			snprintf(buf, sizeof buf, "    (expanded from: %s)",
! 				shortenstring(q->q_alias->q_paddr, 203));
  			putline(buf, mci);
  		}
  	}
--- 816,828 ----
  			printheader = FALSE;
  		}
  
! 		snprintf(buf, sizeof buf, "%s",
! 			 shortenstring(q->q_paddr, MAXSHORTSTR));
  		putline(buf, mci);
  		if (q->q_alias != NULL)
  		{
  			snprintf(buf, sizeof buf, "    (expanded from: %s)",
! 				shortenstring(q->q_alias->q_paddr, MAXSHORTSTR));
  			putline(buf, mci);
  		}
  	}
***************
*** 856,867 ****
  		}
  
  		snprintf(buf, sizeof buf, "%s  (%s)",
! 			shortenstring(q->q_paddr, 203), p);
  		putline(buf, mci);
  		if (q->q_alias != NULL)
  		{
  			snprintf(buf, sizeof buf, "    (expanded from: %s)",
! 				shortenstring(q->q_alias->q_paddr, 203));
  			putline(buf, mci);
  		}
  	}
--- 860,871 ----
  		}
  
  		snprintf(buf, sizeof buf, "%s  (%s)",
! 			shortenstring(q->q_paddr, MAXSHORTSTR), p);
  		putline(buf, mci);
  		if (q->q_alias != NULL)
  		{
  			snprintf(buf, sizeof buf, "    (expanded from: %s)",
! 				shortenstring(q->q_alias->q_paddr, MAXSHORTSTR));
  			putline(buf, mci);
  		}
  	}
diff -cr sendmail-8.9.0/src/sendmail.h sendmail-8.9.1/src/sendmail.h
*** sendmail-8.9.0/src/sendmail.h	Tue May 19 16:36:06 1998
--- sendmail-8.9.1/src/sendmail.h	Wed Jun 24 10:54:16 1998
***************
*** 9,15 ****
   * the sendmail distribution.
   *
   *
!  *	@(#)sendmail.h	8.278 (Berkeley) 5/19/98
   */
  
  /*
--- 9,15 ----
   * the sendmail distribution.
   *
   *
!  *	@(#)sendmail.h	8.280 (Berkeley) 6/5/98
   */
  
  /*
***************
*** 19,25 ****
  # ifdef _DEFINE
  # define EXTERN
  # ifndef lint
! static char SmailSccsId[] =	"@(#)sendmail.h	8.278		5/19/98";
  # endif
  # else /*  _DEFINE */
  # define EXTERN extern
--- 19,25 ----
  # ifdef _DEFINE
  # define EXTERN
  # ifndef lint
! static char SmailSccsId[] =	"@(#)sendmail.h	8.280		6/5/98";
  # endif
  # else /*  _DEFINE */
  # define EXTERN extern
***************
*** 998,1004 ****
  extern int	safeopen __P((char *, int, int, int));
  extern FILE	*safefopen __P((char *, int, int, int));
  extern int	dfopen __P((char *, int, int, int));
! extern bool	filechanged __P((char *, int, struct stat *, int));
  
  
  /*
--- 998,1004 ----
  extern int	safeopen __P((char *, int, int, int));
  extern FILE	*safefopen __P((char *, int, int, int));
  extern int	dfopen __P((char *, int, int, int));
! extern bool	filechanged __P((char *, int, struct stat *));
  
  
  /*
***************
*** 1183,1188 ****
--- 1183,1189 ----
  EXTERN uid_t	DefUid;		/* default uid to run as */
  EXTERN gid_t	DefGid;		/* default gid to run as */
  EXTERN char	*DefUser;	/* default user to run as (from DefUid) */
+ EXTERN uid_t	TrustedFileUid;	/* uid of trusted owner of files and dirs */
  EXTERN MODE_T	OldUmask;	/* umask when sendmail starts up */
  EXTERN int	Verbose;	/* set if blow-by-blow desired */
  EXTERN int	Errors;		/* set if errors (local to single pass) */
diff -cr sendmail-8.9.0/src/snprintf.c sendmail-8.9.1/src/snprintf.c
*** sendmail-8.9.0/src/snprintf.c	Tue May 19 16:36:11 1998
--- sendmail-8.9.1/src/snprintf.c	Thu Jun  4 14:32:02 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)snprintf.c	8.10 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  #include "sendmail.h"
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)snprintf.c	8.11 (Berkeley) 6/4/98";
  #endif /* not lint */
  
  #include "sendmail.h"
***************
*** 83,89 ****
  		DoprEnd[0] = 0;
  	if (SnprfOverflow && tTd(57, 2))
  		printf("\nvsnprintf overflow, len = %ld, str = %s",
! 			(long) count, shortenstring(str, 203));
  	return strlen(str);
  }
  
--- 83,89 ----
  		DoprEnd[0] = 0;
  	if (SnprfOverflow && tTd(57, 2))
  		printf("\nvsnprintf overflow, len = %ld, str = %s",
! 			(long) count, shortenstring(str, MAXSHORTSTR));
  	return strlen(str);
  }
  
***************
*** 394,403 ****
  **	Returns:
  **		Either s or a short version of s.
  */
- 
- #ifndef MAXSHORTSTR
- # define MAXSHORTSTR	203
- #endif
  
  char *
  shortenstring(s, m)
--- 394,399 ----
